-- Copyright (c) 2013 Cloudera, Inc. All rights reserved.
--
-- * Capture the delegation token id for audit correlation.
-- * New ACTIVITY_AUDIT table to store activity info.
-- * New ACTIVITY_LAST_POLL_TIME table to track poll time.
--

create table ACTIVITY_AUDIT (
  ID                    bigint not null,
  SERVICE_NAME          varchar(255) not null,
  ACTIVITY_ID           varchar(255) not null,
  PARENT_ID             bigint,
  ROOT_ID               bigint,
  ACTIVITY_TYPE         varchar(31) not null,
  BEGIN_TS              bigint(20) not null,
  END_TS                bigint(20),
  DELEGATION_TOKEN_ID   varchar(255),
  STATUS                varchar(31),
  USERNAME              varchar(255),
  USER_GROUP            varchar(255),
  HDFS_READ_BYTES       bigint,
  HDFS_WRITE_BYTES      bigint,

  primary key (ID),
  constraint `FK_ACTIVITY_AUDIT_PARENT_ID` foreign key (PARENT_ID) references ACTIVITY_AUDIT (ID) ON DELETE CASCADE,
  constraint `FK_ACTIVITY_AUDIT_ROOT_ID` foreign key (ROOT_ID) references ACTIVITY_AUDIT (ID) ON DELETE CASCADE,
  index IDX_SERVICE (SERVICE_NAME),
  index IDX_ACTIVITY_ID (ACTIVITY_ID)

) ENGINE=InnoDB;

create table ACTIVITY_LAST_POLL_TIME (
  SERVICE_NAME          varchar(255) not null,
  POLL_TS               bigint(20) not null,

  primary key (SERVICE_NAME)
) ENGINE=InnoDB;

--  Add DELEGATION_TOKEN_ID to HDFS tables
com.cloudera.navigator.schema.AddHdfsDelegationTokenId
